//VerankertesLoesen_301d.js
// 24.05.14 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Lst verankerte Objekte

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// testen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// das aktuelle Dokument
var curDoc = app.documents[0];

// die Auswahl speichern und prfen
curSel = app.selection;

// wenn keine Auswahl, wird das ganze Dokument behandelt
if (curSel.length == 0) {
	// alle Textketten
	var allStories = curDoc.stories;
	// eine Schleife durch die Textketten
	for (var s=0; s<allStories.length; s++) {
		// die aktuelle Textkette
		var curStory = allStories[s];
		// die Finden-Funktion aufrufen
		findAnchored(curStory);
	}
}
else {
	for (var s=0; s<curSel.length; s++) {
		if (curSel[s].parent.constructor.name == "Character") {
			releaseObj(curSel[s]);
		}
		else {
			if (curSel[s].hasOwnProperty("baseline") == true) {
				// die aktuelle Textkette
				var curStory = curSel[s].parent;
				// die Finden-Funktion aufrufen
				findAnchored(curStory);
			}
			else if (curSel[s].constructor.name == "TextFrame") {
				// die aktuelle Textkette
				var curStory = curSel[s].parentStory;
				// die Finden-Funktion aufrufen
				findAnchored(curStory);
			}
		}
	}
}

// die letzte Auswahl aufheben
app.selection = null;

// das Ende der Aktion verknden
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Fertig.");
dlog.show();
// eine kleine Pause
$.sleep(999);
// das Fenster schliessen
dlog.close();

// die Funktion zum Finden der Verankerungen
function findAnchored(curStory) {
	// die verankerten Objekte
	var allObj = curStory.allPageItems;
	// eine Schleife durch die Objekte
	for (var n=allObj.length-1; n>-1; n--) {
		var curObj = allObj[n];
		if (curObj.parent.constructor.name == "Character") {
			// die Lsen-Funktion aufrufen
			releaseObj(curObj);
		}
	}
}

// die Funktion zum Lsen der Objekte
function releaseObj(curObj) {
	try {
		// vorsorglich entsperren
		curObj.locked = false;
		curObj.select(SelectionOptions.replaceWith);
		var gB = curObj.geometricBounds;
		app.activeWindow.zoomPercentage = 100;
		app.cut();
		app.paste();
		app.selection[0].move([gB[1], gB[0]]);
	}
	catch (e) {
	}
}